/**
 * test/demos/signals.c
 * Copyright (C) 2008 Markus Broeker
 */

#ifndef _XOPEN_SOURCE
#define _XOPEN_SOURCE 500
#endif

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

void sigproc ()
{
    signal (SIGINT, sigproc);
    printf ("I received the SIGINT Signal\n");
}

void sigquit ()
{
    printf ("I received the SIGQUIT Signal\n");
    /*
     *  0 kills every process in the current process group
     * -1 kills all reachable user processes (dangerous, logout)
     */
    kill (0, SIGKILL);
}

int main (int argc, char **argv)
{
    signal (SIGINT, sigproc);
    signal (SIGQUIT, sigquit);

    printf ("PRESS CTRL-\\ to quit\n");
    for (;;);

    return EXIT_SUCCESS;
}
